package com.iconplus.smartproc.controller;

import com.iconplus.smartproc.model.entity.MetodePenyampaian;
import com.iconplus.smartproc.exception.ResourceNotFoundException;
import com.iconplus.smartproc.repository.MetodePenyampaianRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@CrossOrigin(origins = "http://localhost:8080", allowCredentials = "true")
@RestController
@RequestMapping("/api/metodepenyampaian")
public class MetodePenyampaianController {
	@Autowired
	private MetodePenyampaianRepository metodepenyampaianRepository;

	//get all data
	@GetMapping
	public List<MetodePenyampaian> getAllMetodepenyampaians(){
		return metodepenyampaianRepository.findAll();
	}

	// create
	@PostMapping
	public MetodePenyampaian createMetodepenyampaian(@RequestBody MetodePenyampaian metodepenyampaian) {
		return metodepenyampaianRepository.save(metodepenyampaian);
	}

	// get metodepenyampaian by id rest api
	@GetMapping("/{id}")
	public ResponseEntity<MetodePenyampaian> getMetodepenyampaianById(@PathVariable Long id) {
		MetodePenyampaian metodepenyampaian = metodepenyampaianRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepenyampaian not exist with id :" + id));
		return ResponseEntity.ok(metodepenyampaian);
	}

	// update metodepenyampaian rest api
	@PutMapping("/{id}")
	public ResponseEntity<MetodePenyampaian> updateMetodepenyampaian(@PathVariable Long id, @RequestBody MetodePenyampaian metodePenyampaianDetails){
		MetodePenyampaian metodepenyampaian = metodepenyampaianRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepenyampaian not exist with id :" + id));

		metodepenyampaian.setMetodePenyampaian(metodePenyampaianDetails.getMetodePenyampaian());
		metodepenyampaian.setKeterangan(metodePenyampaianDetails.getKeterangan());

		MetodePenyampaian updatedMetodePenyampaian = metodepenyampaianRepository.save(metodepenyampaian);
		return ResponseEntity.ok(updatedMetodePenyampaian);
	}

	// delete metodepenyampaian rest api
	@DeleteMapping("/{id}")
	public ResponseEntity<Map<String, Boolean>> deleteMetodepenyampaian(@PathVariable Long id){
		MetodePenyampaian metodepenyampaian = metodepenyampaianRepository.findById(id)
				.orElseThrow(() -> new ResourceNotFoundException("Metodepenyampaian not exist with id :" + id));

		metodepenyampaianRepository.delete(metodepenyampaian);
		Map<String, Boolean> response = new HashMap<>();
		response.put("deleted", Boolean.TRUE);
		return ResponseEntity.ok(response);
	}
}



