package com.iconplus.smartproc.helper.base;

import lombok.Data;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.Column;
import javax.persistence.MappedSuperclass;
import java.io.Serializable;
import java.sql.Timestamp;

@Data
@MappedSuperclass
public class BaseEntity implements Serializable {

  @Column(name = "user_created", length = 50)
  private String userCreated;

  @Column(name = "time_created", nullable = false, updatable=false)
  @CreationTimestamp
  private Timestamp timeCreated;

  @Column(name = "user_update", length = 50)
  private String userUpdate;

  @Column(name = "last_update")
  @UpdateTimestamp
  private Timestamp lastUpdate;

}
