package com.iconplus.smartproc.helper.service;

import com.iconplus.smartproc.helper.base.BasePaginationRequest;
import com.iconplus.smartproc.helper.base.BasePaginationResponse;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.beans.factory.annotation.Value;

@Data
@AllArgsConstructor
@NoArgsConstructor
public abstract class BasePaginationService<T extends BasePaginationRequest, V extends BasePaginationResponse> implements BaseService<T, V>{
	
	@Value("${default.page.size}")
    private Integer pageSize;

	@Value("${default.page.number}")
    private Integer pageNumber;
	
	@Value("${default.page.sortBy}")
    private String sortBy;
	
	@Value("${default.page.sortType}")
    private String sortType;

    @Value("${default.page.maxPageSize}")
    private Integer maxPageSize;

}
