package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.Instansi;
import com.iconplus.smartproc.model.projection.InstansiView;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface InstansiRepository extends JpaRepository<Instansi, Long> {

    @Query(value = "SELECT i.id as id," +
            "i.instansi as instansi, " +
            "i.alamat as alamat, " +
            "i.keterangan as keterangan, " +
            "i.isActive as isActive, " +
            "i.isDelete as isDelete " +
            "FROM Instansi i " +
            "WHERE i.isDelete = false " +
            "AND (:search = '' or UPPER(i.instansi) like :search)")
    Page<InstansiView> getListInstansi(String search, Pageable pageable);

    Optional<Instansi> findByIdAndIsDeleteFalse(Long id);

    Optional<Instansi> findByInstansiAndIsDeleteFalse(String instansi);
}
