package com.iconplus.smartproc.service.authentication;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.context.ApiContext;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.ForgotPasswordRequest;
import com.iconplus.smartproc.repository.UsersRepository;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

@Service
public class ForgotPasswordService implements BaseService<ForgotPasswordRequest, EmptyResponse> {

    private ApiContext apiContext;
    private UsersRepository usersRepository;
    public ForgotPasswordService(UsersRepository usersRepository,
                                 ApiContext apiContext) {
        this.usersRepository = usersRepository;
        this.apiContext = apiContext;
    }

    @Override
    public EmptyResponse execute(ForgotPasswordRequest input) {

        Long id = Long.valueOf(apiContext.getUserId());
        var users = usersRepository.findByIdAndIsDeleteFalse(id).orElseThrow(() -> new BusinessException("err", "err", "err"));

        if (!StringUtils.equalsIgnoreCase(input.getCurrentPassword(), users.getPassword()) ||
                StringUtils.equalsIgnoreCase(input.getNewPassword(), users.getPassword()) ||
                !StringUtils.equalsIgnoreCase(input.getConfirmationPassword(), input.getNewPassword())) {
            throw new BusinessException("err", "err", "err");
        }

        users.setPassword(input.getNewPassword());
        usersRepository.save(users);

        return new EmptyResponse();
    }
}
