package com.iconplus.smartproc.service.bidang;

import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.entity.Bidang;
import com.iconplus.smartproc.model.request.BidangRequest;
import com.iconplus.smartproc.model.response.BidangResponse;
import com.iconplus.smartproc.repository.BidangRepository;
import org.springframework.stereotype.Service;

@Service
public class PostCreateBidangService implements BaseService<BidangRequest, BidangResponse> {

    private BidangRepository bidangRepository;

    public PostCreateBidangService(BidangRepository bidangRepository) {
        this.bidangRepository = bidangRepository;
    }

    @Override
    public BidangResponse execute(BidangRequest input) {
        Bidang bidang = Bidang.builder()
                .id(input.getId())
                .instansiId(input.getInstansiId())
                .bidang(input.getBidang())
                .keterangan(input.getKeterangan())
                .isActive(input.getIsActive())
                .isDelete(false)
                .build();

        var result = bidangRepository.save(bidang);
        return BidangResponse.builder()
                .id(result.getId())
                .build();

    }
}
