package com.iconplus.smartproc.service.manajemenuser;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.UsersRequest;
import com.iconplus.smartproc.repository.UsersRepository;
import org.springframework.stereotype.Service;

@Service
public class DeleteUserService implements BaseService<UsersRequest, EmptyResponse> {

    private UsersRepository usersRepository;

    public DeleteUserService(UsersRepository usersRepository) {
        this.usersRepository = usersRepository;
    }

    @Override
    public EmptyResponse execute(UsersRequest input) {

        var users = usersRepository.findByIdAndIsDeleteFalse(input.getId())
                .orElseThrow(() -> new BusinessException("err", "err", "err"));

        users.setIsDelete(true);
        usersRepository.save(users);

        return new EmptyResponse();
    }
}
