package com.iconplus.smartproc.service.sumberdana;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.SumberDanaRequest;
import com.iconplus.smartproc.repository.SumberDanaRepository;
import org.springframework.stereotype.Service;

@Service
public class DeleteSumberDanaService implements BaseService<SumberDanaRequest, EmptyResponse> {

    private SumberDanaRepository sumberDanaRepository;

    public DeleteSumberDanaService(SumberDanaRepository sumberDanaRepository) {
        this.sumberDanaRepository = sumberDanaRepository;
    }

    @Override
    public EmptyResponse execute(SumberDanaRequest input) {
        var sumberDana = sumberDanaRepository.findByIdAndIsDeleteFalse(input.getId()).orElseThrow(() -> new BusinessException("err", "err", "err"));
        sumberDana.setIsDelete(true);
        sumberDanaRepository.save(sumberDana);
        return new EmptyResponse();
    }
}
