package com.iconplus.smartproc.service.sumberdana;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.SumberDanaRequest;
import com.iconplus.smartproc.model.response.SumberDanaResponse;
import com.iconplus.smartproc.repository.SumberDanaRepository;
import org.springframework.stereotype.Service;

@Service
public class PutSumberDanaService implements BaseService<SumberDanaRequest, SumberDanaResponse> {

    private SumberDanaRepository sumberDanaRepository;

    public PutSumberDanaService(SumberDanaRepository sumberDanaRepository) {
        this.sumberDanaRepository = sumberDanaRepository;
    }

    @Override
    public SumberDanaResponse execute(SumberDanaRequest input) {

        var sumberDana = sumberDanaRepository.findByIdAndIsDeleteFalse(input.getId()).orElseThrow(() -> new BusinessException("err", "err", "err"));
        sumberDana.setSumberDana(input.getSumberDana());
        sumberDana.setKeterangan(input.getKeterangan());
        sumberDana.setIsActive(input.getIsActive());
        var result = sumberDanaRepository.save(sumberDana);
        return SumberDanaResponse.builder()
                .id(result.getId())
                .build();

    }
}
