package com.iconplus.smartproc.service.unitinisiator;

import com.iconplus.smartproc.exception.BusinessException;
import com.iconplus.smartproc.helper.model.EmptyResponse;
import com.iconplus.smartproc.helper.service.BaseService;
import com.iconplus.smartproc.model.request.UnitInisiatorRequest;
import com.iconplus.smartproc.repository.UnitInisiatorRepository;
import org.springframework.stereotype.Service;

@Service
public class DeleteUnitInisiatorService implements BaseService<UnitInisiatorRequest, EmptyResponse> {

    private UnitInisiatorRepository unitInisiatorRepository;

    private DeleteUnitInisiatorService(UnitInisiatorRepository unitInisiatorRepository) {
        this.unitInisiatorRepository = unitInisiatorRepository;
    }

    @Override
    public EmptyResponse execute(UnitInisiatorRequest input) {

        var unitInisiator = unitInisiatorRepository.findByIdAndIsDeleteFalse(input.getId()).orElseThrow(() -> new BusinessException("err", "err", "err"));
        unitInisiator.setIsDelete(true);
        unitInisiatorRepository.save(unitInisiator);
        return new EmptyResponse();
    }
}
